package edu;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
*/
public class Circle extends Component implements Tool, ItemListener {
  static Hashtable colorList = new Hashtable ();
  static {
    colorList.put ("white", Color.white);
    colorList.put ("light grey", Color.lightGray);
    colorList.put ("grey", Color.gray);
    colorList.put ("dark grey", Color.darkGray);
    colorList.put ("black", Color.black);
    colorList.put ("red", Color.red);
    colorList.put ("pink", Color.pink);
    colorList.put ("orange", Color.orange);
    colorList.put ("yellow", Color.yellow);
    colorList.put ("green", Color.green);
    colorList.put ("magenta", Color.magenta);
    colorList.put ("cyan", Color.cyan);
    colorList.put ("blue", Color.blue);
  }
  
  public Circle () {
    enableEvents (AWTEvent.MOUSE_EVENT_MASK | AWTEvent.MOUSE_MOTION_EVENT_MASK);
  }

  ElementsContainer contents;
  WBContainer    renderer;

  public void setDisplay (WBContainer _ren) { renderer = _ren; }

  public void setDisplayList (ElementsContainer l) { contents = l; }
  
  public Component getDisplay () { return this; }
  
  public Component getControls () {
    LWContainer controls = new LWContainer ();
    controls.setLayout (new BorderLayout ());
    controls.add ("North", new Label ("Circle Tool", Label.CENTER));
    Choice colorChoice = new Choice ();
    Enumeration e = colorList.keys ();
    while (e.hasMoreElements ())
      colorChoice.addItem ((String) e.nextElement ());
    colorChoice.select ("black");
    controls.add ("Center", colorChoice);
    colorChoice.addItemListener (this);
    return controls;
  }

  public void dispose () { }

  public void itemStateChanged (ItemEvent e) {
    color = (Color) colorList.get (e.getItem ());
  }
  
  boolean active;
  Color color = Color.black;
  int x0, y0, x1, y1;
  CircElement myElement;
    
  public void processEvent (AWTEvent e) {
    super.processEvent (e);
    if (e instanceof MouseEvent) {
      MouseEvent m = (MouseEvent) e;
      switch (m.getID ()) {
        case MouseEvent.MOUSE_PRESSED:
          x0 = m.getX ();
          y0 = m.getY ();
          myElement=new CircElement (x0,y0,1,1,color);
          contents.addElement(myElement);
          break;
        case MouseEvent.MOUSE_RELEASED:
          if (active) {
            x1 = m.getX ();
            y1 = m.getY ();
            active = false;
            myElement.setCord(Math.min (x0, x1), Math.min (y0, y1),
                              1 + Math.abs (x0 - x1), 1 + Math.abs (y0 - y1));
            
          }
          break;
        case MouseEvent.MOUSE_DRAGGED:
          int x2 = active ? x1 : x0, y2 = active ? y1 : y0;
          x1 = m.getX ();
          y1 = m.getY ();
          active = true;
          myElement.setCord( Math.min (x0, x1), Math.min (y0, y1),
                             1 + Math.abs (x0 - x1), 1 + Math.abs (y0 - y1));

          int xm = Math.min (Math.min (x0, x1), x2),
            xM = Math.max (Math.max (x0, x1), x2),
            ym = Math.min (Math.min (y0, y1), y2),
            yM = Math.max (Math.max (y0, y1), y2);
          break;
      }
    }
  }
    
  public void paint (Graphics g) {
    if (active) {
      g.setColor (color);
      g.drawOval (Math.min (x0, x1), Math.min (y0, y1),
                  Math.abs (x0 - x1), Math.abs (y0 - y1));
    }
  }
}
