package uci.edu;

import java.awt.*; 
import java.awt.event.*;
import java.util.*;
import owrti.util.CDRCoderEncoder;
import uci.edu.rti.*;
import uci.edu.*;
import uci.gef.*;
//import uci.gef.demo.*;
import uci.graph.*;


public class NodeElement extends RTIObject implements Element {
  Rectangle bounds;
  Color color;
  Object _node;
  int deltaX=5, deltaY=5, deltaW=5, deltaH=5;

  public NodeElement() { this(10,10,10,10,Color.red,-1); }

  public NodeElement(int _objectID) { this(0,0,0,0,Color.red,_objectID);   }

  public NodeElement (int x, int y, int w, int h, Color c) { this(x,y,w,h,c,-1);     }

  public NodeElement (int x, int y, int w, int h, Color c,int _objectID) {
    bounds = new Rectangle (x, y, w, h);
    color = c;
    setInstanceRTIid(_objectID);
    try{ setObjectClassRTIid(RTILookUpTable.getObjectClassRTIid("SNode3"));}
    catch(ObjectClassNameUnknown ocnu) {	System.out.println("I am here inside  exception");
}
  }

  public Rectangle getBounds () {  return bounds; }
  public void  setBounds( int x,int y,int w,int h) {
	  bounds = new Rectangle(x,y,w,h);
  }
  /**  */
  public void commitTranslation(int dX, int dY) {
      bounds = new Rectangle (dX,dY,bounds.width,bounds.height);
	     System.out.println(" commitTranslation() of /noideelemenet");

	fireUpdate(); 
  }// end of commitTranslation()

  /**  */
  public void updateTranslation(int dX, int dY) {
    fireUpdate();
  }// end of commitTranslation()

  public boolean isSelectable() { return isPublishable(); }

 
  public void paint (Graphics g) { 
    Color cc = g.getColor();
	System.out.println("I am in PAINT of NODEELEMENT");
    g.setColor (color);
    if ((bounds.width == 1) && (bounds.height == 1))
         g.drawLine (bounds.x, bounds.y, bounds.x, bounds.y);
    else 
	{
	drawnode(g);
		}
    g.setColor(cc);
  }// end of paint()
 protected GraphFactory _factory;

public void drawnode(Graphics g)
{
	CmdCreateNode cm = new CmdCreateNode(uci.gef.demo.SampleNode3.class, "Node Three");
	_node = cm.makeNode();
    Globals.nextMode();
	System.out.println("I am in drawnode()1 of NODEELEMENT"+bounds);
    Editor _editor = Globals.curEditor();
   	System.out.println("I am in drawnode()2 of NODEELEMENT editor : "+ _editor);
    GraphModel gm = _editor.getGraphModel();
	System.out.println("I am in drawnode()3 of NODEELEMENT gm : "+gm);
    GraphNodeRenderer renderer = _editor.getGraphNodeRenderer();
	System.out.println("I am in drawnode()4 of NODEELEMENT renderer : "+renderer);
    Layer lay = _editor.getLayerManager().getActiveLayer();
	System.out.println("I am in drawnode()5 of NODEELEMENT layer : "+lay);
    FigNode _pers = renderer.getFigNodeFor(gm, lay, _node);
	System.out.println("I am in drawnode()6 of NODEELEMENT pers : "+_pers);
	if (_pers != null)
	{
		_pers.setBounds(bounds.x,bounds.y,bounds.width,bounds.height);
	//	updateTranslation(bounds.x,bounds.y);
		_pers.paint(g);
	}
}

/*
// create a new instance of the node
 public Object makeNode() {
    Object newNode;
    Class nodeClass = (Class) getArg("className", uci.gef.demo.SampleNode.class);
    try { newNode = nodeClass.newInstance(); }
    catch (java.lang.IllegalAccessException ignore) { return null; }
    catch (java.lang.InstantiationException ignore) { return null; }
	System.out.println("I am creating a new node Name of the node "+newNode);
    if (newNode instanceof GraphNodeHooks)
      ((GraphNodeHooks)newNode).initialize();
    return newNode;
  }
*/

  public void setCord(int x, int y, int w, int h) {
    deltaX=0;deltaY=0; deltaW=0;deltaH=0;
    deltaW-=Math.abs(w-bounds.width); deltaH-=Math.abs(h-bounds.height);
    bounds = new Rectangle (x, y, w, h);
    if(WBDEBUG.DEBUG1) System.out.println("setCord of NodeElement");
    fireUpdate();
  }// end of setCord()  

  UpdateListener reflect=null;

  public void setUpdateListener(UpdateListener lis) { reflect=lis; }
   
  final void fireUpdate() {
      System.out.println(" fireUpdate() of nodeelement");

     if( reflect!=null )
   {
    reflect.updateOccurred(new UpdateEvent(this));
     System.out.println(" fireUpdate() of /noideelemenet");

	}


  }// end of fireUpdate()

  /// RTIObject hooks
  public Properties getAttributes(boolean state) {
    Properties ret=new Properties();
    if(state || deltaX<1) { ret.put("x",new String(CDRCoderEncoder.toByte(bounds.x)));deltaX=5; }
    if(state || deltaY<1) { ret.put("y",new String(CDRCoderEncoder.toByte(bounds.y)));deltaY=5; }
    if(state || deltaW<1) { ret.put("width",new String(CDRCoderEncoder.toByte(bounds.width)));deltaW=5; }
    if(state || deltaH<1) { ret.put("height",new String(CDRCoderEncoder.toByte(bounds.height))); deltaH=5; }
    if(WBDEBUG.DEBUG1) System.out.println(" CHANGED!!! getAttributes() ");
    return ret;
  }// end of getAttributes() 

  public void setAttributes(Properties p) {
    if(p!=null) {
      String value = (String) p.get("x");
      if(value!=null) bounds.x = CDRCoderEncoder.extractInt(value.getBytes());
      value = (String) p.get("y");
      if(value!=null) bounds.y = CDRCoderEncoder.extractInt(value.getBytes());
      value = (String) p.get("width");
      if(value!=null) bounds.width = CDRCoderEncoder.extractInt(value.getBytes());
      value = (String) p.get("height");
      if(value!=null) bounds.height = CDRCoderEncoder.extractInt(value.getBytes());
      fireUpdate();    
      if(WBDEBUG.DEBUG1) System.out.println(" CHANGED!!! setAttributes() ");
    }// end of if
  }// end of setAttributes() 

  public void reflectAttributes(Vector p) {
    if(p!=null&&p.size()>0) {
      if(p.contains("x")) deltaX=0; 
      if(p.contains("y")) deltaY=0; 
      if(p.contains("width")) deltaW=0;
      if(p.contains("height")) deltaH=0;
      deltaX=0;deltaY=0;deltaW=0;deltaH=0;
      fireUpdate();    
    }// end of if
  }// end of reflectAttributes() 
}// end of class NodeElement
