package uci.edu;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.event.*;

import RTIcap.*;             // The package containing our stubs.
import npacrti.*;            // The package containing our stubs.
import org.omg.CosNaming.*;  // 
import org.omg.CORBA.*;      // All CORBA applications need these classes.
import owrti.util.*;

import uci.edu.rti.*;
import uci.edu.util.*;
/**
*
* @author Hasan Timucin Ozdemir
* @date   March 16, 1999 (Updated on March 16, 1999)
*
*/
public class WB extends JFrame implements ActionListener
{
   java.lang.Object guard = new java.lang.Object();
  String  fedName = "Whiteboard";
  String  fedCnfName = fedName+".fed";
   
  RTIcap.RTIambassador rtiAmb;
  PrintWriter myLog;


  AppletProps parent;
  Hashtable ctrlImages, ctrlClasses;
  JPanel infoHolder;
  WBContainer display;

  Tool currentTool;

  JMenuItem exitItem;
  String ExitTxt = "Exit";
  String myName = "WBC";

  boolean       advanceGranted = false;
  double        currentTime = 0.0; 
  double        timeStep = 5.0; 
  double        requestTime ; 
  boolean       isConnected = false;
   short   federateId;

  EntityManager eManager;

  public WB (AppletProps a, RTIcap.RTIambassador _rtiAmb)
  {
    super ("Whiteboard");
    rtiAmb = _rtiAmb;
    Date aDate = new Date();
    myName = "WBC"+aDate; myName = myName.replace(' ','_');

    try 
    { myLog = new PrintWriter(new FileWriter("wb.log"),true);
    } catch( java.io.IOException ioe) {}

    doRealyConnect();

    JMenuBar menuBar;
    JMenu menu, submenu;
    JMenuItem menuItem;
    JCheckBoxMenuItem cbMenuItem;
    JRadioButtonMenuItem rbMenuItem;

     addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {

                WB.this.doExit();
            }
     });

     //Create the menu bar.
     menuBar = new JMenuBar();
     setJMenuBar(menuBar);

     //Build the first menu.
     menu = new JMenu("Menu");
     menuBar.add(menu);

     //openItem = new JMenuItem(OpenURL);
     exitItem = new JMenuItem(ExitTxt);
     //menu.add(openItem);
     //menu.addSeparator();
     menu.add(exitItem);
     //openItem.addActionListener(this);
     exitItem.addActionListener(this);

    //enableEvents (AWTEvent.WINDOW_EVENT_MASK);
    parent = a;

    eManager.addUpdateListener(new NWRTI(rtiAmb));

    getContentPane().add ("Center", display);

    JPanel ctrlHolder = new JPanel ();
    JPanel ctrls      = new JPanel ();
    
    getContentPane().add ("West", ctrlHolder);

    ctrlHolder.setLayout (new FlowLayout (FlowLayout.LEFT, 0, 0));
    ctrlHolder.add (ctrls);
    ctrls.setLayout (new GridLayout (0, 1, 0, 2));
    ctrlImages = new Hashtable ();
    ctrlClasses = new Hashtable ();

    try {
      URL u = new URL (parent.getCodeBase (), "config.txt");
      BufferedReader r = new BufferedReader (new InputStreamReader (u.openStream (), "latin1"));
      String line;
     
      while ((line = r.readLine ()) != null)
      {
        StringTokenizer t = new StringTokenizer (line, ",");
        String name = t.nextToken (), imageName = t.nextToken (), className = t.nextToken ();
        ImageIcon theImage = new ImageIcon(new URL(parent.getCodeBase ()+imageName));
        JButton button = new JButton(name,theImage);
        ctrls.add (button);
        ctrlImages.put (name, theImage);

        try
        { ctrlClasses.put (name, Class.forName (className));
        } catch (ClassNotFoundException ex)
          { button.setEnabled (false); }

        button.addActionListener (this);

      }// end of while

      r.close ();

    } catch (IOException ex)  { ex.printStackTrace (); }
          
    infoHolder = new JPanel ();
    infoHolder.setLayout (new BorderLayout ());

    JButton logo = new JButton("logo", new ImageIcon("1865x2.gif")); //middle.gif") );
    logo.setEnabled (false);
    infoHolder.add ( logo , BorderLayout.WEST);
    getContentPane().add (infoHolder,BorderLayout.SOUTH);
    pack ();
    setVisible(true);

  }// end of CONSTRUCTOR

  protected void processWindowEvent (WindowEvent e) {
    super.processWindowEvent (e);
    if (e.getID () == WindowEvent.WINDOW_CLOSING)
      setVisible (false);
  }

  protected void processEvent (AWTEvent e) {
    if ((e instanceof ActionEvent) && (e.getSource () instanceof AppletProps)) {
      init ((AppletProps) e.getSource ());
    } else super.processEvent (e);
  }

  void init(AppletProps a ) { }

  /**
  * ActionListener interface to collect the user events.
  * @param e ActionEvent
  */
  public void 
  actionPerformed (ActionEvent e)
  {
    
    if( e.getSource() instanceof JMenuItem)
    {
     JMenuItem source = (JMenuItem)(e.getSource());
     if( source.getText().equals(ExitTxt)) doExit();
     //else if( source.getText().equals(OpenURL) ) openURLProcess();
    }
    else
    {

    ImageIcon theImage = (ImageIcon) ctrlImages.get (e.getActionCommand ());
    Class theClass = (Class) ctrlClasses.get (e.getActionCommand ());
    System.out.println( e.getActionCommand ()+" selected! ");
    try {
      if (currentTool != null) {
        currentTool.dispose ();
        currentTool = null;
      }
      currentTool = (Tool) theClass.newInstance ();
      currentTool.setDisplayList (eManager);
      currentTool.setDisplay (display);

      JButton button = new JButton(e.getActionCommand (), theImage);
      button.setEnabled (false);
      infoHolder.removeAll ();
      infoHolder.add ("West", button);
      infoHolder.add ("Center", currentTool.getControls ());
      infoHolder.validate ();
      display.setTool(currentTool);
    } catch (InstantiationException ex)
      { ex.printStackTrace (); } 
      catch (IllegalAccessException ex)
      { ex.printStackTrace (); }
    }
  }

   /**
   * Gets the RTTI (Meta-Object Protocol MOP) handles.
   */
   boolean getRtiIds() {
      boolean ret = false;
      if( rtiAmb != null ) {
         short objId = -1;
         int   attId = -1;

         try
         { objId = rtiAmb.getObjectClassHandle("Rectangle");
           RTILookUpTable.addObjectClass("Rectangle",objId);
         } catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}

         if( objId>-1 )
         try
         { attId = rtiAmb.getAttributeHandle("x",objId );
           RTILookUpTable.addObjectClassAttribute("Rectangle","x",attId);
           attId = rtiAmb.getAttributeHandle("y",objId );
           RTILookUpTable.addObjectClassAttribute("Rectangle","y",attId);
           attId = rtiAmb.getAttributeHandle("transx",objId );
           RTILookUpTable.addObjectClassAttribute("Rectangle","transx",attId);
           attId = rtiAmb.getAttributeHandle("transy",objId );
           RTILookUpTable.addObjectClassAttribute("Rectangle","transy",attId);
           attId = rtiAmb.getAttributeHandle("width",objId );
           RTILookUpTable.addObjectClassAttribute("Rectangle","width",attId);
           attId = rtiAmb.getAttributeHandle("height",objId );
           RTILookUpTable.addObjectClassAttribute("Rectangle","height",attId);
           //ret = true;
         } catch( RTIcap.ObjectClassNotDefined icnd ) {}
           catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}

         try
         { objId = rtiAmb.getObjectClassHandle("Circle");
           RTILookUpTable.addObjectClass("Circle",objId);
         } catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}

         if( objId>-1 )
         try
         { attId = rtiAmb.getAttributeHandle("x",objId );
           RTILookUpTable.addObjectClassAttribute("Circle","x",attId);
           attId = rtiAmb.getAttributeHandle("y",objId );
           RTILookUpTable.addObjectClassAttribute("Circle","y",attId);
           attId = rtiAmb.getAttributeHandle("transx",objId );
           RTILookUpTable.addObjectClassAttribute("Circle","transx",attId);
           attId = rtiAmb.getAttributeHandle("transy",objId );
           RTILookUpTable.addObjectClassAttribute("Circle","transy",attId);
           attId = rtiAmb.getAttributeHandle("width",objId );
           RTILookUpTable.addObjectClassAttribute("Circle","width",attId);
           attId = rtiAmb.getAttributeHandle("height",objId );
           RTILookUpTable.addObjectClassAttribute("Circle","height",attId);
           ret = true;
         } catch( RTIcap.ObjectClassNotDefined icnd ) {}
           catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}

      }// end of if
      return ret;
   }// end of getRtiIds()

   /**
   *
   * Describe our interest for publishing objects and attributes.
   * Describe our interest for receiving objects and attributes.
   * Describe our interest for publishing interations and parameters.
   * Describe our interest for receiving interations and parameters.
   *
   */
   boolean publishSubscribe() {
     boolean ret = false;
     if( rtiAmb != null ) {

        short ocID = RTILookUpTable.getObjectClassRTIid("Rectangle");
        short[] myAttributes = RTILookUpTable.getObjectClassAttributeRTIHandles("Rectangle");

        try
        { rtiAmb.subscribeObjectClassAttributes( ocID, myAttributes , RTIcap._Boolean.RTI_TRUE);
          rtiAmb.publishObjectClass(ocID , myAttributes );
          ret = true;
        } catch( RTIcap.ObjectClassNotDefined  flsc)    { doExit(" exception ObjectClassNotDefined! "); }
          catch( RTIcap.AttributeNotDefined  fnem)      { doExit(" exception AttributeNotDefined!"); }
          catch( RTIcap.FederateNotExecutionMember  fnem) { doExit(" exception FederateNotExecutionMember!"); }
          catch( RTIcap.RTIinternalError  ie)   { doExit(" exception RTIinternalError!"); }
          catch( RTIcap.RestoreInProgress  rip) { doExit(" exception RestoreInProgress!"); }
          catch( RTIcap.SaveInProgress  sip)    { doExit(" exception SaveInProgress!"); }

        ocID = RTILookUpTable.getObjectClassRTIid("Circle");
        myAttributes = RTILookUpTable.getObjectClassAttributeRTIHandles("Circle");

        try
        { rtiAmb.subscribeObjectClassAttributes( ocID, myAttributes , RTIcap._Boolean.RTI_TRUE);
          rtiAmb.publishObjectClass(ocID , myAttributes );
          ret = true;
        } catch( RTIcap.ObjectClassNotDefined  flsc)    { doExit(" exception ObjectClassNotDefined! "); }
          catch( RTIcap.AttributeNotDefined  fnem)      { doExit(" exception AttributeNotDefined!"); }
          catch( RTIcap.FederateNotExecutionMember  fnem) { doExit(" exception FederateNotExecutionMember!"); }
          catch( RTIcap.RTIinternalError  ie)   { doExit(" exception RTIinternalError!"); }
          catch( RTIcap.RestoreInProgress  rip) { doExit(" exception RestoreInProgress!"); }
          catch( RTIcap.SaveInProgress  sip)    { doExit(" exception SaveInProgress!"); }

     }// end of if  
     try 
     { eManager.registerObjectFactory("Rectangle",new RTIObjFactory("edu.RectElement","Rectangle",null));
       eManager.registerObjectFactory("Circle",new RTIObjFactory("edu.CircElement","Circle",null));}
     catch(ClassNotFoundException cnf) {}
     return ret;
   }// end of publishSubscribe()

   /**
   * 
   * We want to join the Federation but we do not know its ID and
   * whether it is on. Therefore, we first try to create this Federation.
   * If this federation is  already exists, we will receive the exception.
   * If not, it will be created for us.
   * Then we need to join this execution and get ourself a federate id.
   * 
   */
   boolean joinFederationExecution(RTIcap.FederateAmbassador fedAmb) {
      boolean ret = false;
      if( rtiAmb != null ) {
         try {
           rtiAmb.createFederationExecution(fedName,fedCnfName);
         } catch( RTIcap.FederationExecutionAlreadyExists icnd) {/*good*/}
           catch( RTIcap.RTIinternalError ie) { doExit("RTIinternalError: while createFederationExecution for "+fedName); }
         try
         { federateId = rtiAmb.joinFederationExecution(myName,fedName,fedAmb);
           ret = true;
         } catch( RTIcap.FederateAlreadyExecutionMember fnem) 
           { doExit("FederateAlreadyExecutionMember:"+myName+" is in use! for "+fedName+" execution! "); }
           catch( RTIcap.FederationExecutionDoesNotExist icnd) { doExit("Forgot to create Fed Ex?"); }
           catch( RTIcap.CouldNotOpenFED fnem)  { doExit("CouldNotOpenFED"); }
           catch( RTIcap.ErrorReadingFED fnem)  { doExit("ErrorReadingFED");}
           catch( RTIcap.SaveInProgress sip)    { doExit("SaveInProgress"); }
           catch( RTIcap.RestoreInProgress rip) { doExit("RestoreInProgress"); }
           catch( RTIcap.RTIinternalError ie)   { doExit("RTIinternalError"); }
      }// end of if
      return ret;
   }// end of joinFederationExecution() 

  /**
  */
  void deleteObjects()  {
      if( rtiAmb != null ) {
         Enumeration e = eManager.getElements();
         while( e.hasMoreElements() ) {
           RTIObject obj = (RTIObject) e.nextElement();
           if( obj!=null && obj.isPublishable() )
           try 
           { rtiAmb.deleteObjectInstance(obj.getInstanceRTIid(),"");
           } catch(RTIcap.ObjectNotKnown ie)  { giveError("ObjectNotKnown"); }
             catch(RTIcap.DeletePrivilegeNotHeld ie) { giveError("DeletePrivilegeNotHeld"); }
             catch(RTIcap.FederateNotExecutionMember ie) {giveError("FederateNotExecutionMember"); }
             catch(RTIcap.SaveInProgress ie) {giveError("SaveInProgress"); }
             catch(RTIcap.RestoreInProgress ie) {giveError("RestoreInProgress"); }
             catch(RTIcap.RTIinternalError ie) {giveError("RTIinternalError"); }
         }// end of while
      }// end of if
   }// end of deleteObjects() 
   

  /**
  *
  * Before we leave the Federation
  *  1. Delete all the object that we are suppose(promised) to simulate.
  *  2. resign from the federation.
  *  3. Try to destroy the federation execution. Note that if there 
  *     are still federates in the Federation, the federation execution
  *     won't be stopped. Only, we resign it. 
  *
  */
  void leaveFederationExecution()  {
      if( rtiAmb != null ) {
         deleteObjects();         
         try 
         { rtiAmb.resignFederationExecution(RTIcap.ResignAction.DELETE_OBJECTS_AND_RELEASE_ATTRIBUTES);
         } catch( RTIcap.InvalidResignAction ie)    { giveError("InvalidResignAction"); }
           catch( RTIcap.FederateOwnsAttributes ie) { giveError("FederateOwnsAttributes"); }
           catch( RTIcap.FederateNotExecutionMember ie) {giveError("FederateNotExecutionMember"); }
           catch( RTIcap.RTIinternalError ie)           {giveError("RTIinternalError"); }
         try 
         { rtiAmb.destroyFederationExecution(fedName);
         } catch( RTIcap.FederationExecutionDoesNotExist icnd) { giveError("FederationExecutionDoesNotExist"); }
           catch( RTIcap.FederatesCurrentlyJoined ie) { giveError("FederatesCurrentlyJoined "); }
           catch( RTIcap.RTIinternalError ie)         { giveError("RTIinternalError"); }
      }// end of if
   }// end of leaveFederationExecution() 

   /** Ticks the RTIambassador. */
   public void tickRTI( long sleepTime ) {
     if(rtiAmb!=null) try { rtiAmb.tick( ); } catch( RTIcap.RTIinternalError aa ) {}
   }// end of tickRTI()
 
   /** Ticks the RTIambassador.*/
   void tickRTI() { if(rtiAmb!=null) try { rtiAmb.tick( ); } catch( RTIcap.RTIinternalError aa ) {}
   }// end of tickRTI()

  /**
  * Connects to the Federation Execution
  */
  void doRealyConnect()
  {
      int count = 0;

      myLog.println(" before WBFedAmb definition ");

      eManager = new EntityManager(rtiAmb);
      display = new WBContainer (eManager, new Dimension (256, 256));
      display.setLayout (new BorderLayout ());
      display.setBackground(Color.white);
      eManager.addUpdateListener(display);
      
      /*******************************************************************/
      /** Define FederateAmbassador                                      */
      /*******************************************************************/
      WBFedAmb fedAmb = new WBFedAmb((RTIObjectsContainer)eManager);
      org.omg.CORBA.ORB.init().connect(fedAmb);

      myLog.println(" ChatFedAmb is defined ");
      
      /************************************************************/
      /** Create FederationExecution, get RTI id of the objects,  */
      /** attributes, interactions, and parameters.               */
      /** Define interest for Subscription/Publishing.            */
      /** Define my simulated object.                             */
      /************************************************************/
      if( joinFederationExecution(fedAmb) && getRtiIds() && 
          publishSubscribe() ) //&& registerRti() )
      {
        
        /*********************************************************************/
        /** TimeConstrained : we want to receive timestamped events in order */
        /*********************************************************************/
        resetTimeAdvanceGranted();

        try
        { 
          rtiAmb.enableTimeConstrained( );
        } catch( RTIcap.TimeAdvanceAlreadyInProgress aa ) {}
          catch( RTIcap.EnableTimeConstrainedPending aa ) {}
          catch( RTIcap.TimeConstrainedAlreadyEnabled aa ) {}
          catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

        /***************************************************/
        /** Tick RTI to get timeConstrainedEnabled message */
        /***************************************************/
        tickRTI(2);

        /**********************************************************/
        /** TimeRegulating : We want to vote for time advancement */
        /**********************************************************/
        resetTimeAdvanceGranted();

        try
        { 
          rtiAmb.enableTimeRegulation( currentTime, 5.0 );

        } catch( RTIcap.TimeAdvanceAlreadyInProgress aa ) {}
          catch( RTIcap.EnableTimeRegulationPending aa ) {}
          catch( RTIcap.ConcurrentAccessAttempted aa ) {}
          catch( RTIcap.TimeRegulationAlreadyEnabled aa ) {}
          catch( RTIcap.InvalidLookahead aa ) {}
          catch( RTIcap.InvalidFederationTime aa ) {}
          catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

        /**************************************************/
        /** Tick RTI to get timeRegulationEnabled message */
        /**************************************************/
        tickRTI(2);

        try
        { 
           rtiAmb.enableAsynchronousDelivery( );
           isConnected = true;

        } catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.AsynchronousDeliveryAlreadyEnabled aa ) {}
          catch( RTIcap.ConcurrentAccessAttempted aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

      }// end of if 

  }// end of doRealyConnect()

  /**
  * Displays the error message in the warning window.
  * @param mess Error message.
  */
  void giveError(String mess)
  {
     JOptionPane.showMessageDialog( this, "Sorry!"+"\n"+mess,"",
                                    JOptionPane.ERROR_MESSAGE);

  }// end of giveError()

  /** Move the frame back, and destroy the execution. */
  void doExit() { doExit(null);  }// end of doExit()

  /** Move the frame back, and destroy the execution. */
  void doExit(String msg) {
     toBack();
     if(isConnected) leaveFederationExecution();
     if(msg==null || msg.length()==0 ) System.exit(0);
     else { ErrorReport.displayErrorMessage(msg); System.exit(1); }
  }// end of doExit()

   /**
   */
   public void
   resetTimeAdvanceGranted()
   { synchronized(guard) { advanceGranted = false; } 
   }// end of resetTimeAdvanceGranted()

   /**
   * This method will be invoked by HwFededarateAmbassador object whenever
   *
   *   timeAdvanceGrant 
   *   timeConstrainedEnabled
   *   timeRegulationEnabled
   *
   * messages received.
   *
   */
   public void
   setTimeAdvanceGranted()
   { synchronized(guard) { advanceGranted = true; } 
   }// end of setTimeAdvanceGranted()

   /**
   */
   public boolean
   isTimeAdvanceGranted()
   { return advanceGranted ; 
   }// end of isTimeAdvanceGranted()

   /**
   */
   public void
   setCurrentTime( double _newTime)
   { 
     if( _newTime >= currentTime ) currentTime = _newTime;

   }// end of setCurrentTime()

}// end of WB

