package uci.edu;

import java.awt.*;
import java.util.*;
import java.lang.Thread;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.event.*;

/**
*/
public class 
WBContainer extends JPanel implements UpdateListener 
{

  //ObservableList elements;
  ElementsContainer elements;
  Dimension dim;
 
  /**
  * @param l 
  * @param d
  * @see edu.ObservableList
  * @see Dimension
  */  
  public WBContainer (ElementsContainer elements, Dimension dim) { 
    enableEvents (AWTEvent.MOUSE_EVENT_MASK | AWTEvent.MOUSE_MOTION_EVENT_MASK);
    this.elements = elements;
    this.dim = dim;
    //elements.addUpdateListener (this);
    //setOpaque(true);
  }

  Tool currentTool;

  public void setTool( Tool cTool ) { currentTool=cTool; }

  public Enumeration getElements() { return elements.getElements(); }

  protected void processEvent (AWTEvent e) {
    if( currentTool!=null ) currentTool.processEvent(e);
    else super.processEvent (e);
  }

  public Dimension getMinimumSize ()   { return new Dimension (dim); }

  public Dimension getPreferredSize () { return getMinimumSize (); }

  public void updateOccurred (UpdateEvent e) {    System.out.println(" updateoccured() of WEBContainer ");
   repaint (); }

  /*public void addElement( Element ele )
  {
    System.out.println("addElement:");
    elements.addElement(ele);
    repaint(0);
  }

  public void removeElement( Element ele )
  {
    if(WBDEBUG.DEBUG1) System.out.println("removeElement:");
    elements.remove(ele);
    repaint();
  }*/

  public void paint (Graphics g) {
    System.out.println(" paint of WEBContainer ");
    update(g);
  }// end of paint()

  public void paintComponent (Graphics g) {
    System.out.println(" paintComponent of WEBContainer ");
    update(g);
  }// end of paint()

  Image offscreen;
  Graphics offgraphics;
  Dimension offscreensize;

  public void update(Graphics g) {
  System.out.println("update() from WBContainer.java");
     Dimension d = getSize();
     if ((offscreen == null) || 
         (d.width != offscreensize.width) ||
         (d.height != offscreensize.height)) {
        offscreen = createImage(d.width, d.height);
        offscreensize = d;
        offgraphics = offscreen.getGraphics();
        offgraphics.setFont(getFont());
     }// end of if
     offgraphics.setColor(getBackground());
     offgraphics.fillRect(0, 0, d.width, d.height);
     Rectangle clip = g.getClipBounds ();
     if (clip == null) clip = new Rectangle (getSize ());
     Enumeration els = elements.getElements ();
     while (els.hasMoreElements ()) {
       Object obj = els.nextElement ();
       if( obj instanceof Element ) {
         Element el = (Element) obj; 
		 System.out.println(" OBJECT GOT HERE IS "+el);
			 
         if ((el != null) && el.getBounds ().intersects (clip))
		{
			 System.out.println(" boundary of rectangle is  X : " + el.getBounds().x +" Y : "+ el.getBounds().y + " W : "+ el.getBounds().width + " H : "+el.getBounds().height );
			 el.setBounds(el.getBounds().x,el.getBounds().y,el.getBounds().width,el.getBounds().height);
             el.paint (offgraphics);
			  }
       }// end of if
     }// end of while()
	 System.out.println(" I AM GONNA PAINT OBJECT ");
     g.drawImage(offscreen, 0, 0, null );
  }// end of update()

}// end of WBContainer

