package uci.edu.dmi;
import java.lang.reflect.*;
/**
* @author Hasan Timucin Ozdemir
* @date   March 16, 1999 (Updated on March 16, 1999)
*/
public class GenericMessage {

  Class    tclass;
  Object   target;
  String   methodName;
  Object[] Args;

  public GenericMessage(Class tclass, Object target, String methodName, Object[] Args) 
         throws IllegalArgumentException {
    if (tclass == null) throw new IllegalArgumentException(" Class is NULL");
    try{ getMethod(tclass,methodName,Args,target==null); 
    } catch(NoSuchMethodException nsme) 
      { throw new IllegalArgumentException(" No Method definition"); }
    this.tclass=tclass; this.target=target; 
    this.methodName=methodName; this.Args=Args;
  }// end of CONSTRUCTOR

  public GenericMessage(Object target, String methodName, Object[] Args) 
         throws IllegalArgumentException {
    if (target == null) throw new IllegalArgumentException(" Target is NULL");
    try{ getMethod(target.getClass(),methodName,Args,target==null); 
    } catch(NoSuchMethodException nsme) 
      { throw new IllegalArgumentException(" No Method definition"); }
    this.tclass=target.getClass(); this.target=target; 
    this.methodName=methodName; this.Args=Args;
  }// end of CONSTRUCTOR

  public Object execute() throws NoSuchMethodException {
    Object ret = null;
    try 
    {	  System.out.println("execute() of Generic Message"); 
 Method meth = getMethod(tclass,methodName,Args,target == null);

      ret = meth.invoke(target,Args);
    } catch (InvocationTargetException e) 
      { throw new NoSuchMethodException("InvocationTargetException"+methodName); 
      } catch (IllegalAccessException e) 
        { throw new NoSuchMethodException("IllegalAccessException"); }
    return ret;
  }// end of execute()

  public Object execute(Object trg) throws NoSuchMethodException {
    Object ret = null;
    try 
    {	  System.out.println("execute(object ) of Generic Message"); 
 Method meth = getMethod(trg.getClass(),methodName,Args,trg == null);

      ret = meth.invoke(trg,Args);
    } catch (InvocationTargetException e) 
      { throw new NoSuchMethodException("InvocationTargetException2222"+methodName); 
      } catch (IllegalAccessException e) 
        { throw new NoSuchMethodException("IllegalAccessException"); }
    return ret;
  }// end of execute()

  private static Method getMethod(Class theClass, String methodName, 
    Object[] args, boolean useStatic) throws NoSuchMethodException {
    Method[] meths = theClass.getMethods();
	  System.out.println("getMethod() of Generic Message"); 

    int numberOfArguments = 0;
    if (args != null) {
      numberOfArguments = args.length;
    }
    for(int i=0;i<meths.length;i++) {
      if (meths[i].getName().equals(methodName) &&
          meths[i].getParameterTypes().length == numberOfArguments &&
          (!useStatic || (meths[i].getModifiers() & Modifier.STATIC) != 0)) {
        // weve got the right number of arguments
        // check to see if they are equal or assignable
        boolean match = true;
        Class[] types = meths[i].getParameterTypes();
        for(int j=0;j<numberOfArguments && match;j++) {
          match = match && 
             (args[j] == null ||
              types[j].equals(args[j].getClass()) ||
              types[j].isAssignableFrom(args[j].getClass()));
        }
        if (match) {
          return meths[i];
        } else {
        }
      }
    }
    throw new NoSuchMethodException("cannot find method " + 
      methodName + " in class " + theClass);
  }// end of getMethod()

}// end of GenericMessage

