package uci.edu.dmi;
import  java.util.Enumeration;
/**
* Hasan Timucin Ozdemir
* @date   March 16, 1999 (Updated on March 16, 1999)
*/
public class Invoker extends Thread {
   private boolean fStopNow;
   private long fStartedProcess;
   private GenericMessageBroadcaster fList;
   private GenericMessage message;
   private boolean fIsProcessActive = false;
   private boolean messageArrived=false;

   Invoker(int id, int pri, GenericMessageBroadcaster list) {
      super("Notifier "+pri+":"+id);
      setPriority(pri);
      fList = list;
      start();
   }

   public void run() {
      while (!fStopNow) {
         try {
            fList.waitForBroadcast(this);
            resetProcessTime();
            fIsProcessActive = true;
            Enumeration e = fList.getListeners();
            if(e.hasMoreElements() ) while( e.hasMoreElements() ) message.execute(e.nextElement());
            else message.execute();
         } catch (InterruptedException ex) {
            if (fStopNow) return;
            //System.out.println("Object exceeded maximum time or time to stop");
         } catch (Exception ex) {
            //System.err.println("Unexpected invocation error: " + ex);
            //ex.printStackTrace(System.err);
         } finally {
            fIsProcessActive = false;
         }
      }
   }

   /**
   */
   public void setGenericMessage(GenericMessage c) { message = c; }

   /**
   * Sets the stop flag which will cause the run() method to terminate after
   * completing current activity
   */
   public void timeToStop() {
      fStopNow = true;
      interrupt();
   }// end of timeToStop()

   /**
    * Gets the time since the last callback was started based on the current
    * system time. This value is meaningful only if isCallbackActive()
    * returns true
    */
   public long getElapsedProcessTime() {
      return getElapsedProcessTime(System.currentTimeMillis());
   }

   /**
    * Sets the time since the last process was started based on the system time
    * passed into the method. This value is meaningful only if isProcessActive()
    * returns true
    */
   public long getElapsedProcessTime(long curr) {
      return curr - fStartedProcess;
   }

   /**
    * Gets whether this invoker is currently executing a callback.
    */
   public boolean isProcessActive() {
      return fIsProcessActive;
   }

   /**
   * Resets the elapsed process time to 0. 
   */
   public void resetProcessTime() {
      fStartedProcess = System.currentTimeMillis();
   }

   final void checkForTimeout(long curr, long max) {
      if (!fIsProcessActive) {
         return;
      }

      if (getElapsedProcessTime(curr) > max) {
         interrupt();
      }
   }
}// end of Class Invoker

