package uci.edu.dmi;

import java.util.*;
import java.lang.reflect.*;
/**
* @author Hasan Timucin Ozdemir
* @date   March 16, 1999 (Updated on March 16, 1999)
*/
public class ObjFactory {
  String  className=null;
  Object[] parameters = null;
  
  /**
  * @param className
  * @param rtiObjectClassName
  * @param parameters
  */
  public ObjFactory (String className, Object[] parameters )             
         throws ClassNotFoundException {
    if(className==null) throw new ClassNotFoundException(); 
    Class c = Class.forName(className);
    this.className=className;
    this.parameters=parameters;
  }// end of CONSTRUCTOR

  /** 
  * @return Object 
  */
  public Object getNewInstance () throws ClassNotFoundException {
    Object ret = null;
		  System.out.println("I am creating a new instance");

    try
    { Class c = Class.forName(className);
      if(parameters!=null && parameters.length>0) {
	  		System.out.println("entering if in objfactory");

        Class[] constructorparameters = new Class[parameters.length];
        for(int i=0;i< parameters.length;i++) 
          constructorparameters[i] = parameters[i].getClass();
        Constructor ctr = c.getConstructor(constructorparameters);
        ret=ctr.newInstance(parameters);
  		System.out.println("exiting if in objfactory");

      } else ret = c.newInstance();
	  
    } catch(java.lang.NoSuchMethodException e1) 
      { throw new ClassNotFoundException("NoSuchMethodException"); }
      catch(InstantiationException e2) 
      { throw new ClassNotFoundException("InstantiationException"); }
      catch(IllegalAccessException e3) 
      { throw new ClassNotFoundException("IllegalAccessException"); }
      catch(InvocationTargetException e4) 
      { throw new ClassNotFoundException("InvocationTargetException"); }
    return ret;
  }// end of getNewInstance()

}// end of ObjFactory
  
