package uci.edu.rti;
import uci.edu.*;
import RTIcap.*;
/**
* @author Hasan Timucin Ozdemir
* @date   March 16, 1999 (Updated on March 16, 1999)
*/
public class NWRTI implements UpdateListener { 
  RTIcap.RTIambassador rtiAmb=null;

  public NWRTI(RTIcap.RTIambassador rtiAmb) { this.rtiAmb=rtiAmb; }
     
  public void   updateOccurred(UpdateEvent evt) { 
    //if(WBDEBUG.DEBUG1) 
   System.out.println(" NWRTI.updateOccurred()");
    if ( evt.getSource() instanceof RTIObject && rtiAmb!=null ) {
      RTIObject obj = (RTIObject) evt.getSource() ;
      if( obj.isPublishable() ) {   /// TIMUCIN 05.04.1999
        RTIcap.AttributeHandleValuePair[] attr = obj.getUpdatedAttributes(false); 
        if( attr!=null && attr.length>0 && obj.getInstanceRTIid()>-1 ) {
          try {   
            rtiAmb.updateAttributeValues(obj.getInstanceRTIid(),attr,"");
          } catch (RTIcap.ObjectNotKnown onk) {}
            catch (RTIcap.AttributeNotDefined onk) {}
            catch (RTIcap.AttributeNotOwned onk) {}
            catch (RTIcap.FederateNotExecutionMember onk) {}
            catch (RTIcap.SaveInProgress onk) {}
            catch (RTIcap.RestoreInProgress onk) {}
            catch (RTIcap.RTIinternalError onk) {}
         }// end of if
      }// end of if
    } else if(WBDEBUG.DEBUG1) System.out.println(" NWRTI is not RTIObject "+evt.getSource().toString()); // end  of if
  }// end of updateOccurred()

}// end of NWRTI

