package uci.gef;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.event.*;

import RTIcap.*;             // The package containing our stubs.
import npacrti.*;            // The package containing our stubs.
import org.omg.CosNaming.*;  // 
import org.omg.CORBA.*;      // All CORBA applications need these classes.
import owrti.util.*;

import uci.edu.rti.*;
import uci.edu.util.*;
import uci.edu.*;
import javax.swing.event.*;
import javax.swing.border.*;

import uci.ui.*;
import uci.graph.*;
import uci.gef.demo.*;
import uci.gef.event.*;

/** A window that displays a toolbar, a connected graph editing pane,
 *  and a status bar. */

public class JGraphFrame extends JFrame
implements ActionListener,IStatusBar, Cloneable, ModeChangeListener {

  ////////////////////////////////////////////////////////////////
  // instance variables

   java.lang.Object guard = new java.lang.Object();
  String  fedName = "Gefdemo";
  String  fedCnfName = fedName+".fed";
   
  RTIcap.RTIambassador rtiAmb;
  
  AppletProps parent;
  Hashtable  ctrlClasses;
   boolean       advanceGranted = false;
  double        currentTime = 0.0; 
  double        timeStep = 5.0; 
  double        requestTime ; 
  boolean       isConnected = false;
  short   federateId;
  JMenuItem exitItem;
  String ExitTxt = "Exit";
  Date dt =new Date();
  String myName = "WBC"+dt ;
  WBContainer display;
  EntityManager eManager;
  /** The toolbar (shown at top of window). */
  protected ToolBar _toolbar = new PaletteFig();
  /** The graph pane (shown in middle of window). */
  protected JGraph _graph;
  /** A statusbar (shown at bottom ow window). */
  protected JLabel _statusbar = new JLabel(" ");
  
  protected JPanel _mainPanel = new JPanel(new BorderLayout());
  protected JPanel _graphPanel = new JPanel(new BorderLayout());
  protected JMenuBar _menubar = new JMenuBar();

  ////////////////////////////////////////////////////////////////
  // constructor

  /** Contruct a new JGraphFrame with the title "untitled" and a new
   *  DefaultGraphModel. */

  public JGraphFrame(RTIcap.RTIambassador _rtiAmb,AppletProps a) {
	  this("Gefdemo",new JGraph(),_rtiAmb,a);
  }
  /** Contruct a new JGraphFrame with the title "untitled" and the
   *  given GraphModel. */
  public JGraphFrame(GraphModel gm) {
    this("untitled");
    setGraphModel(gm);
  }
  
  /** Contruct a new JGraphFrame with the given title and a new
   *  DefaultGraphModel. */
  public JGraphFrame(String title) {
    this(title, new JGraph(),null,null);
  }

  public JGraphFrame(String title, Editor ed) {
    this(title, new JGraph(ed),null,null);
  }
  
  /** Contruct a new JGraphFrame with the given title and given
   *  JGraph. All JGraphFrame contructors call this one. */
  public JGraphFrame(String title, JGraph jg,RTIcap.RTIambassador _rtiAmb,AppletProps a) {
    super(title);
	rtiAmb=_rtiAmb;//store the rtiamb
	parent =a;//store properties
    _graph = jg;
    java.awt.Container content = getContentPane();
	_graph.getEditor().damageAll();
	doRealyConnect();
	_graph.getEditor().damageAll();
    setUpMenus();
    content.setLayout(new BorderLayout());
    content.add(_menubar, BorderLayout.NORTH);    
    _graphPanel.add(_graph, BorderLayout.CENTER);
    _graphPanel.setBorder(new EtchedBorder(EtchedBorder.LOWERED));
    _mainPanel.add(_toolbar, BorderLayout.NORTH);
    _mainPanel.add(_graphPanel, BorderLayout.CENTER);
    content.add(_mainPanel, BorderLayout.CENTER);
    //content.add(_statusbar, BorderLayout.SOUTH);
	content.add(display,BorderLayout.SOUTH);
	setSize(300, 250);
	 _graph.addModeChangeListener(this);
	 eManager.addUpdateListener(new NWRTI(rtiAmb));

    ctrlClasses = new Hashtable ();
    try {
      URL u = new URL (parent.getCodeBase (), "config.txt");
      BufferedReader r = new BufferedReader (new InputStreamReader (u.openStream ()));
      String line;
     
      while ((line = r.readLine ()) != null)
      {
		StringTokenizer t = new StringTokenizer (line, ",");
        String name = t.nextToken (), className = t.nextToken ();
        try
        {
			ctrlClasses.put (name, Class.forName (className));
		
        } catch (ClassNotFoundException ex)
          { System.out.println("U r dead sweety"); }

  
      }// end of while

      r.close ();
  }catch (IOException ex)  {ex.printStackTrace (); }
  }
  /** Set up the menus and keystrokes for menu items. Subclasses can
   *  override this, or you can use setMenuBar(). */
  protected void setUpMenus() {
    JMenu file = new JMenu("File");
    file.setMnemonic('F');
    _menubar.add(file);
	setDisplayList(eManager); 
	//for exiting from the menu
     exitItem = file.add(new CmdExit());
	exitItem.addActionListener(this);
  }

public ElementsContainer getElementsContainer()
{	   	System.out.println(" getElementsContainer() of JGraphFrame "+contents);
	return contents;}

protected void processEvent (AWTEvent e) {
    if ((e instanceof ActionEvent) && (e.getSource () instanceof AppletProps)) {
      init ((AppletProps) e.getSource ());
    } else super.processEvent (e);
  }
  ////////////////////////////////////////////////////////////////
  // accessors
void init(AppletProps a ) { }

  public JGraph getGraph() { return _graph; }
  public void setGraph(JGraph g) { _graph = g; }

  public void setGraphModel(GraphModel gm) { _graph.setGraphModel(gm); }
  public GraphModel getGraphModel() { return _graph.getGraphModel(); }
  public void setGraphNodeRenderer(GraphNodeRenderer rend) {
    _graph.getEditor().setGraphNodeRenderer(rend);
  }
  public GraphNodeRenderer getGraphNodeRenderer() {
    return _graph.getEditor().getGraphNodeRenderer();
  }
  public void setGraphEdgeRenderer(GraphEdgeRenderer rend) {
    _graph.getEditor().setGraphEdgeRenderer(rend);
  }
  public GraphEdgeRenderer getGraphEdgeRenderer() {
    return _graph.getEditor().getGraphEdgeRenderer();
  }
  
  public void setToolBar(ToolBar tb) {
    _toolbar = tb;
    _mainPanel.add(_toolbar, BorderLayout.NORTH);    
  }
  public ToolBar getToolBar() { return _toolbar; }

  public void setJMenuBar(JMenuBar mb) {
    _menubar = mb;
    getContentPane().add(_menubar, BorderLayout.NORTH);
  }
  public JMenuBar getJMenuBar() { return _menubar; }


  ////////////////////////////////////////////////////////////////
  // display related methods

  public void setVisible(boolean b) {
    super.setVisible(b);
    if (b) Globals.setStatusBar(this);
  }

  ////////////////////////////////////////////////////////////////
  // Cloneable implementation
/*
  public Object clone() {
    return null; //needs-more-work
  }*/

  ////////////////////////////////////////////////////////////////
  // IStatusListener implementation

  /** Show a message in the statusbar. */
  public void showStatus(String msg) {
    if (_statusbar != null) _statusbar.setText(msg);
  }
    ElementsContainer contents;

    
	  public void setDisplayList (ElementsContainer l) { 
		  contents = l; 
	   	System.out.println(" setDisplayList () of JGraphFrame "+contents);
	 
	  }
  ////////////////////////////////////////////////////////////////
  // ModeChangeListener implementation
  public void modeChange(ModeChangeEvent mce) {
  	_graph.getEditor().damageAll();
	System.out.println("I am in THIS MODE : " +Globals.nextMode());
	SelectionManager sm =_graph.getEditor().getSelectionManager();
	Vector figs = sm.getFigs();
	for (int i = 0 ;i< figs.size();i++){
    Fig selectedFig = (Fig) figs.elementAt(i);
    if (!(selectedFig instanceof FigNode1)) continue;
    Rectangle bbox = selectedFig.getBounds();
	System.out.println("Coordinates from this appln. are : " +selectedFig);
		// x : "+bbox.x+" y: "+bbox.y+" w: "+bbox.width+" h: "+bbox.height);
	FigNode1 fign1 = (FigNode1)selectedFig;
	NodeElement ne =(NodeElement) fign1.getelement();
	_graph.getEditor().damaged(selectedFig);
	_graph.getEditor().damageAll();
	ne.setCord(bbox.x,bbox.y,bbox.width,bbox.height);
	ne.commitTranslation(bbox.x,bbox.y); 
	}
    if (!Globals.getSticky() && Globals.mode() instanceof ModeSelect)
      _toolbar.unpressAllButtons();
  }

  public void 
  actionPerformed (ActionEvent e)
  {
    if( e.getSource() instanceof JMenuItem)
    {
     JMenuItem source = (JMenuItem)(e.getSource());
     if( source.getText().equals(ExitTxt)) doExit();
     }
    else
    {
   // ImageIcon theImage = (ImageIcon) ctrlImages.get (e.getActionCommand ());
    Class theClass = (Class) ctrlClasses.get (e.getActionCommand ());
    }
  }
  /**
  * Connects to the Federation Execution
  */
  void doRealyConnect()
  {
      int count = 0;
      eManager = new EntityManager(rtiAmb);
      display = new WBContainer (eManager, new Dimension (256, 256));
      eManager.addUpdateListener(display);
      /*******************************************************************/
      /** Define FederateAmbassador                                      */
      /*******************************************************************/
	  WBFedAmb fedAmb = new WBFedAmb((RTIObjectsContainer)eManager);
	  org.omg.CORBA.ORB.init().connect(fedAmb);
      
      /************************************************************/
      /** Create FederationExecution, get RTI id of the objects,  */
      /** attributes, interactions, and parameters.               */
      /** Define interest for Subscription/Publishing.            */
      /** Define my simulated object.                             */
      /************************************************************/
      if( joinFederationExecution(fedAmb) && getRtiIds() && 
          publishSubscribe() ) //&& registerRti() )
      {
        
        /*********************************************************************/
        /** TimeConstrained : we want to receive timestamped events in order */
        /*********************************************************************/
        resetTimeAdvanceGranted();
		try
        { 
          rtiAmb.enableTimeConstrained( );
		 } catch( RTIcap.TimeAdvanceAlreadyInProgress aa ) {}
          catch( RTIcap.EnableTimeConstrainedPending aa ) {}
          catch( RTIcap.TimeConstrainedAlreadyEnabled aa ) {}
          catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

        /***************************************************/
        /** Tick RTI to get timeConstrainedEnabled message */
        /***************************************************/
        tickRTI(2);
        /**********************************************************/
        /** TimeRegulating : We want to vote for time advancement */
        /**********************************************************/
        resetTimeAdvanceGranted();

        try
        { 
          rtiAmb.enableTimeRegulation( currentTime, 5.0 );

        } catch( RTIcap.TimeAdvanceAlreadyInProgress aa ) {}
          catch( RTIcap.EnableTimeRegulationPending aa ) {}
          catch( RTIcap.ConcurrentAccessAttempted aa ) {}
          catch( RTIcap.TimeRegulationAlreadyEnabled aa ) {}
          catch( RTIcap.InvalidLookahead aa ) {}
          catch( RTIcap.InvalidFederationTime aa ) {}
          catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

        /**************************************************/
        /** Tick RTI to get timeRegulationEnabled message */
        /**************************************************/
        tickRTI(2);

        try
        { 
           rtiAmb.enableAsynchronousDelivery( );
           isConnected = true;

        } catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.AsynchronousDeliveryAlreadyEnabled aa ) {}
          catch( RTIcap.ConcurrentAccessAttempted aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

      }// end of if 
  }// end of doRealyConnect()

  /**
   * 
   * We want to join the Federation but we do not know its ID and
   * whether it is on. Therefore, we first try to create this Federation.
   * If this federation is  already exists, we will receive the exception.
   * If not, it will be created for us.
   * Then we need to join this execution and get ourself a federate id.
   * 
   */
   boolean joinFederationExecution(RTIcap.FederateAmbassador fedAmb) {
      boolean ret = false;
      if( rtiAmb != null ) {
         try {
           rtiAmb.createFederationExecution(fedName,fedCnfName);
         } catch( RTIcap.FederationExecutionAlreadyExists icnd) {/*good*/}
           catch( RTIcap.RTIinternalError ie) { doExit("RTIinternalError: while createFederationExecution for "+fedName); }
         try
         { 	 federateId = rtiAmb.joinFederationExecution(myName,fedName,fedAmb);
		     ret = true;
         } catch( RTIcap.FederateAlreadyExecutionMember fnem) 
           { doExit("FederateAlreadyExecutionMember:"+myName+" is in use! for "+fedName+" execution! "); }
           catch( RTIcap.FederationExecutionDoesNotExist icnd) { doExit("Forgot to create Fed Ex?"); }
           catch( RTIcap.CouldNotOpenFED fnem)  { doExit("CouldNotOpenFED"); }
           catch( RTIcap.ErrorReadingFED fnem)  { doExit("ErrorReadingFED");}
           catch( RTIcap.SaveInProgress sip)    { doExit("SaveInProgress"); }
           catch( RTIcap.RestoreInProgress rip) { doExit("RestoreInProgress"); }
           catch( RTIcap.RTIinternalError ie)   { doExit("RTIinternalError"); }
      }// end of if
      return ret;
   }// end of joinFederationExecution() 

   /**
   * Gets the RTTI (Meta-Object Protocol MOP) handles.
   */
	boolean getRtiIds() {
      boolean ret = false;
      if( rtiAmb != null ) {
         short objId = -1;
         int   attId = -1;
         try
         { 
           objId = rtiAmb.getObjectClassHandle("SNode3");
           RTILookUpTable.addObjectClass("SNode3",objId);
         } catch( RTIcap.FederateNotExecutionMember icnd ) { System.out.println("U got ex1");}
           catch( RTIcap.NameNotFound icnd ) { System.out.println("U got ex2");}
           catch( RTIcap.RTIinternalError icnd ) { System.out.println("U got ex3");}
         if( objId>-1 )
		 {
         try
         { attId = rtiAmb.getAttributeHandle("x",objId );
           RTILookUpTable.addObjectClassAttribute("SNode3","x",attId);
           attId = rtiAmb.getAttributeHandle("y",objId );
           RTILookUpTable.addObjectClassAttribute("SNode3","y",attId);
           attId = rtiAmb.getAttributeHandle("width",objId );
           RTILookUpTable.addObjectClassAttribute("SNode3","width",attId);
           attId = rtiAmb.getAttributeHandle("height",objId );
           RTILookUpTable.addObjectClassAttribute("SNode3","height",attId);
           ret = true;
         } catch( RTIcap.ObjectClassNotDefined icnd ) {}
           catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}
         }
	  }
      return ret;
   }// end of getRtiIds()

 /**
   *
   * Describe our interest for publishing objects and attributes.
   * Describe our interest for receiving objects and attributes.
   * Describe our interest for publishing interactions and parameters.
   * Describe our interest for receiving interations and parameters.
   *
   */
   boolean publishSubscribe() {
     boolean ret = false;
     if( rtiAmb != null ) {
        short ocID = RTILookUpTable.getObjectClassRTIid("SNode3");
        short[] myAttributes = RTILookUpTable.getObjectClassAttributeRTIHandles("SNode3");

        try
        { rtiAmb.subscribeObjectClassAttributes( ocID, myAttributes , RTIcap._Boolean.RTI_TRUE);
          rtiAmb.publishObjectClass(ocID , myAttributes );
          ret = true;
        } catch( RTIcap.ObjectClassNotDefined  flsc)    { doExit(" exception ObjectClassNotDefined! "); }
          catch( RTIcap.AttributeNotDefined  fnem)      { doExit(" exception AttributeNotDefined!"); }
          catch( RTIcap.FederateNotExecutionMember  fnem) { doExit(" exception FederateNotExecutionMember!"); }
          catch( RTIcap.RTIinternalError  ie)   { doExit(" exception RTIinternalError!"); }
          catch( RTIcap.RestoreInProgress  rip) { doExit(" exception RestoreInProgress!"); }
          catch( RTIcap.SaveInProgress  sip)    { doExit(" exception SaveInProgress!"); }

       
     try 
     {
		 eManager.registerObjectFactory("SNode3",new RTIObjFactory("uci.edu.NodeElement","SNode3",null));
     }
     catch(ClassNotFoundException cnf) {	  System.out.println("I found an exception");
}
	 }
     return ret;
   }// end of publishSubscribe()

 /**
  */
  void deleteObjects()  {
      if( rtiAmb != null ) {
         Enumeration e = eManager.getElements();
         while( e.hasMoreElements() ) {
           RTIObject obj = (RTIObject) e.nextElement();
           if( obj!=null && obj.isPublishable() )
           try 
           { rtiAmb.deleteObjectInstance(obj.getInstanceRTIid(),"");
           } catch(RTIcap.ObjectNotKnown ie)  { giveError("ObjectNotKnown"); }
             catch(RTIcap.DeletePrivilegeNotHeld ie) { giveError("DeletePrivilegeNotHeld"); }
             catch(RTIcap.FederateNotExecutionMember ie) {giveError("FederateNotExecutionMember"); }
             catch(RTIcap.SaveInProgress ie) {giveError("SaveInProgress"); }
             catch(RTIcap.RestoreInProgress ie) {giveError("RestoreInProgress"); }
             catch(RTIcap.RTIinternalError ie) {giveError("RTIinternalError"); }
         }// end of while
      }// end of if
   }// end of deleteObjects() 

/**
  *
  * Before we leave the Federation
  *  1. Delete all the object that we are suppose(promised) to simulate.
  *  2. resign from the federation.
  *  3. Try to destroy the federation execution. Note that if there 
  *     are still federates in the Federation, the federation execution
  *     won't be stopped. Only, we resign it. 
  *
  */
  void leaveFederationExecution()  {
      if( rtiAmb != null ) {
         deleteObjects();         
         try 
         { rtiAmb.resignFederationExecution(RTIcap.ResignAction.DELETE_OBJECTS_AND_RELEASE_ATTRIBUTES);
         } catch( RTIcap.InvalidResignAction ie)    { giveError("InvalidResignAction"); }
           catch( RTIcap.FederateOwnsAttributes ie) { giveError("FederateOwnsAttributes"); }
           catch( RTIcap.FederateNotExecutionMember ie) {giveError("FederateNotExecutionMember"); }
           catch( RTIcap.RTIinternalError ie)           {giveError("RTIinternalError"); }
         try 
         { rtiAmb.destroyFederationExecution(fedName);
         } catch( RTIcap.FederationExecutionDoesNotExist icnd) { giveError("FederationExecutionDoesNotExist"); }
           catch( RTIcap.FederatesCurrentlyJoined ie) { giveError("FederatesCurrentlyJoined "); }
           catch( RTIcap.RTIinternalError ie)         { giveError("RTIinternalError"); }
      }// end of if
   }// end of leaveFederationExecution() 

   /** Ticks the RTIambassador. */
   public void tickRTI( long sleepTime ) {
     if(rtiAmb!=null) try { rtiAmb.tick( ); } catch( RTIcap.RTIinternalError aa ) {}
   }// end of tickRTI()
 
   /** Ticks the RTIambassador.*/
   void tickRTI() { if(rtiAmb!=null) try { rtiAmb.tick( ); } catch( RTIcap.RTIinternalError aa ) {}
   }// end of tickRTI()
 /**
  * Displays the error message in the warning window.
  * @param mess Error message.
  */
  void giveError(String mess)
  {
     JOptionPane.showMessageDialog( this, "Sorry anusha!"+"\n"+mess,"",
                                    JOptionPane.ERROR_MESSAGE);

  }// end of giveError()

  /** Move the frame back, and destroy the execution. */
  void doExit() { doExit(null);  }// end of doExit()

  /** Move the frame back, and destroy the execution. */
  void doExit(String msg) {
     toBack();
     if(isConnected) leaveFederationExecution();
     if(msg==null || msg.length()==0 ) System.exit(0);
     else { ErrorReport.displayErrorMessage(msg); System.exit(1); }
  }// end of doExit()

   /**
   */
   public void
   resetTimeAdvanceGranted()
   { synchronized(guard) { advanceGranted = false; } 
   }// end of resetTimeAdvanceGranted()

   /**
   * This method will be invoked by HwFededarateAmbassador object whenever
   *
   *   timeAdvanceGrant 
   *   timeConstrainedEnabled
   *   timeRegulationEnabled
   *
   * messages received.
   *
   */
   public void
   setTimeAdvanceGranted()
   { synchronized(guard) { advanceGranted = true; } 
   }// end of setTimeAdvanceGranted()

   /**
   */
   public boolean
   isTimeAdvanceGranted()
   { return advanceGranted ; 
   }// end of isTimeAdvanceGranted()

   /**
   */
   public void
   setCurrentTime( double _newTime)
   { 
     if( _newTime >= currentTime ) currentTime = _newTime;

   }// end of setCurrentTime()

  static final long serialVersionUID = 7412677544814835664L;
} /* end class JGraphFrame */
