
// File: ModePlace.java
// Classes: ModePlace
// Original Author: jrobbins@ics.uci.edu
// $Id: ModePlace.java,v 1.14 1999/03/17 21:26:27 jrobbins Exp $

package uci.gef;

import java.awt.*;
import java.util.*;
import java.awt.event.*;
import uci.gef.demo.*;
import uci.graph.*;
import uci.edu.*;

/** Mode to place new a FigNode on a node in a diagram.
 *  Normally invoked via CmdCreateNode.
 *
 * @see ActionCreateNode
 * @see FigNode
 */

public class ModePlace1 extends ModePlace {

  ////////////////////////////////////////////////////////////////
  // instance variables
	
	ElementsContainer contents;
  /** The (new) node being placed. It might be an existing node that
   *  is adding a new FigNode. */
 /* protected Object _node;

  /** The (new) FigNode being placed. It might be an existing
   *  FigNode on an existing node being place in another diagram. */
  /*protected FigNode _pers;

  protected GraphFactory _factory;*/

  ////////////////////////////////////////////////////////////////
  // constructor

  /** Construct a new instance of ModePlace and store the given node. */
  public ModePlace1(GraphFactory gf) {
	super(gf);
  }

	public void store(ElementsContainer cont)
   {
   	System.out.println(" StoreElementsContainer () of CmdCreateNode1 I know what to do I guess now"+cont);

	contents = cont;
   }
  
  ////////////////////////////////////////////////////////////////
  // event handlers

  public void mouseReleased(MouseEvent me) {
    if (me.isConsumed()) return;
	FigNode1 fign1 =null ;
    GraphModel gm = _editor.getGraphModel();
    if (!(gm instanceof MutableGraphModel)) return;
    MutableGraphModel mgm = (MutableGraphModel) gm;
    if (mgm.canAddNode(_node)) {
      _editor.add(_pers);
      mgm.addNode(_node);
      Fig encloser = null;
      Rectangle bbox = _pers.getBounds();
      Layer lay = _editor.getLayerManager().getActiveLayer();
      Vector otherFigs = lay.getContents();
      Enumeration others = otherFigs.elements();
      while (others.hasMoreElements()) {
        Fig otherFig = (Fig) others.nextElement();
		fign1 = (FigNode1)otherFig;
        if (!(otherFig instanceof FigNode1)) continue;
        if (otherFig.equals(_pers)) continue;
        Rectangle trap = otherFig.getTrapRect();
        if (trap != null && (trap.contains(bbox.x, bbox.y) &&
             trap.contains(bbox.x + bbox.width, bbox.y + bbox.height)))
          encloser = otherFig;
      }
      _pers.setEnclosingFig(encloser);
      if (_node instanceof GraphNodeHooks)
	((GraphNodeHooks)_node).postPlacement(_editor);
	  //add the element
	NodeElement ne = new NodeElement();
	fign1.store(ne);
	contents.addElement(ne);
	ne.setCord(bbox.x,bbox.y,bbox.width,bbox.height);
	ne.commitTranslation(bbox.x,bbox.y); 

      _editor.getSelectionManager().select(_pers);
    }
    done();
    me.consume();
  }

  public void done() {
    super.done();
    _pers = null;
    _node = null;
  }

  /** Paint the FigNode being dragged around. */
  public void paint(Graphics g) { if (_pers != null) _pers.paint(g); }

  static final long serialVersionUID = -6165862797493969514L;
} /* end class ModePlace */
