// File: BasicApplication.java
// Class: BasicApplication
// original author: jrobbins@ics.uci.edu
// $Id: BasicApplication.java,v 1.14 1999/03/17 03:18:50 jrobbins Exp $


package uci.gef.demo;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.event.*;
import java.net.*;
import java.io.*;
import java.util.*;

import uci.edu.*;

import RTIcap.*;             // The package containing our stubs.
import npacrti.*;            // The package containing our stubs.
import org.omg.CosNaming.*;  // 
import org.omg.CORBA.*;      // All CORBA applications need these classes.
import owrti.util.*;

import uci.gef.*;
import uci.graph.*;



/** A simple example of the minimum code needed to build an
 *  application using GEF. */

public class BasicApplication implements AppletProps{

  ////////////////////////////////////////////////////////////////
  // instance variables

  protected JGraphFrame _jgf;

  ////////////////////////////////////////////////////////////////
  // constructors

  public BasicApplication(Properties props, RTIambassador rtiAmb ) {
  //passing on the rtiambassador to frame
    _jgf = new JGraphFrame(rtiAmb,this);
    _jgf.setToolBar(new SamplePalette(_jgf.getElementsContainer())); //needs-more-work
    // make the delete key remove elements from the underlying GraphModel
    _jgf.getGraph().bindKey(new CmdDispose(), KeyEvent.VK_DELETE, 0);

    _jgf.setBounds(10, 10, 500, 500);
    _jgf.setVisible(true);
    LayerManager lm =  _jgf.getGraph().getEditor().getLayerManager();
    LayerPerspective lay = (LayerPerspective) lm.getActiveLayer();
    lay.addNodeTypeRegion(SNode3.class, new Rectangle(250, 10, 200, 200));

    DefaultGraphModel dgm = (DefaultGraphModel) _jgf.getGraphModel();
    System.out.println("finished adding nodes");
  }
  
 public URL getCodeBase()
  { 
    URL url = null;
    try
    {  url = new URL("file:"+System.getProperty("user.dir")+System.getProperty("file.separator"));
    } catch( MalformedURLException mue) {}

    return url;

  }// end of getCodeBase()

  /**
  */
  public Image getImage(URL url, String fName)
  {
    System.out.println(" load:"+url+fName);
    return Toolkit.getDefaultToolkit().getImage((url+fName));
    
  }// end of getImage()


  ////////////////////////////////////////////////////////////////
  // main
 public static void 
   main(String args[])
   {
     try
     {
        // Create and initialize the ORB
        ORB orb = ORB.init(args, null);
      try 
        {
           String strIOR = owrti.util.KernelLocator.getRTIKernelIOR();
           if( strIOR != null )
           {
            RTIKernelInterface rtiKernel = RTIKernelInterfaceHelper.narrow(orb.string_to_object(strIOR));

              // Get the Version of the Kernel
              String version = rtiKernel.getVersion();
              System.out.println(" Version is : "+version);      

              RTIambassador rtiAmb = rtiKernel.createRTIAmbassador();

                 BasicApplication demo = new BasicApplication(null,rtiAmb);

           } else System.out.println(" IOR file is empty| \n "+
                        "I can not find the address of RTIKernelInterface ");

        } catch(java.io.FileNotFoundException fnf) 
          { System.out.println("File Not Found"); }
          
     } catch(Exception e) 
       {
         System.out.println("ERROR found here is : " + e);
         e.printStackTrace(System.out);
       }  
  }

} /* end class BasicApplication */

